/**
 * 业务协议签名
 * 调用方法
 * getAgreements
 * 参数
 * bizUnitId//业务id
 * callbackFn//回调方法,会返回一个obj参数包含bizUnitId,sn,titles,signValues,agreementIds,md5Content
 * 
 * @param bizUnitId
 * @returns
 */
AGR={};
AGR.signParams={};
AGR.params={};
function getAgreements(bizUnitId,callbackFn,skipProtocols,notCheckCa) {
	AGR.agreementCallbackFn=callbackFn;
	AGR.bizUnitId=bizUnitId;
	AGR.skipProtocols=skipProtocols;
	AGR.notCheckCa=notCheckCa;
	App.showPreloader();
	AGR.showDoc=false;
	$$.ajax({
		url: '/getAgreements.do?rnd=' + new Date().getTime(),
		method: 'POST',
        data: {bizUnitId:bizUnitId},
		success:AGR.getAgreementsSuccess ,
		error: function(){
			App.hidePreloader();
			AGR.errorFun("网络连接失败");
   		},
   		timeout: function(){
			App.hidePreloader();
			AGR.errorFun("网络连接失败");
   		}
	});
}

//资管产品协议获取方法
function getAgreementsForFundCode(APP_bizUnitId,fund_code,callbackFn,skipProtocols) {
	AGR.bizUnitId=APP_bizUnitId;
	AGR.agreementCallbackFn=callbackFn;
	AGR.skipProtocols=skipProtocols;
	AGR.fund_code=fund_code;
	App.showPreloader();
	$$.ajax({
		url: '/queryAgreement.do?rnd=' + new Date().getTime(),
		method: 'POST',
        data: {fund_code:AGR.fund_code},
		success: AGR.getAgreementsSuccess,
		error: function(){
			AGR.errorFun("网络连接失败");
   		},
   		timeout: function(){
			AGR.errorFun("网络连接失败");
   		}
	});
}


AGR.getAgreementsSuccess=function (data) {
	if(data === 'no login'){
		App.popup('.popup-login');
	}else{
		var dataObj = JSON.parse(data);
		if (dataObj.errorNo == '0') {//已登录
	    	if(dataObj==null || dataObj.list.length == 0){
				AGR.errorFun("无相关协议");
	    		return;
	    	}
	    	AGR.isSign=true;
			AGR.data=dataObj;
			AGR.protocols=dataObj.list;
			AGR.hasSignSize=0;
			AGR.sn="";
			AGR.signParams={
				bizUnitId:AGR.bizUnitId,
				caKind:dataObj.caKind,
				sn:"",
				titles:"",
				signValues:"",
				agreementIds:"",
				md5Content:""
			};
			if(AGR.notCheckCa){
				dataObj.caKind=0;
			}
			if (dataObj.caKind+"" == "1") {
				AGR.sn=dataObj.sn_zd;
			} else if (dataObj.caKind+"" == "2") {
				AGR.sn=dataObj.sn_zj;
			} else if (dataObj.caKind+"" == "3") {
				if(dataObj.sn_zd==""){
					AGR.sn=dataObj.sn_zj;
				}else if(dataObj.sn_zj==""){
					AGR.sn=dataObj.sn_zd;
				}else{
					AGR.sn=dataObj.sn_zd+","+dataObj.sn_zj;
				}
			}
			if(AGR.skipProtocols==true){
				AGR.verifySn(AGR.sn,AGR.verifySnSuccess);
			}
		} else {//未登录
			AGR.errorFun(dataObj.errorInfo);
		}
	}
};


AGR.verifySnSuccess=function(){
	if(AGR.protocols.length!=0){
		CERT.sign(AGR.signParams.sn,AGR.protocols[AGR.hasSignSize].encryptContent,"AGR.certSignCallBack");
	}else{
		if(!AGR.agreementCallbackFn(AGR.signParams)){
			displayView.goBack();
		}
		App.hidePreloader();
	}
};


AGR.verifySn=function(sn,callbackFn){
	AGR.verifySnSuccessCallback=callbackFn;
	AGR.snArray = sn.replace(/^,|,$/gi,"").split(",");
	if(AGR.snArray.length==0||AGR.snArray[0]==""){
		App.hidePreloader();
		if(AGR.data.caKind+""=="0"){
			AGR.agreementCallbackFn(AGR.signParams);
		}else if(AGR.data.caKind+""=="1"){
			App.alert("您还未申请中登证书,请到网厅申请中登证书","温馨提示",function() {});
		}else{
			App.alert("您还未申请自建证书,请到网厅申请自建证书","温馨提示",function() {});
		}
		return;
	}
};

//签名成功回调
AGR.signSuccess=function(){

	if(AGR.skipProtocols==true){
		AGR.agreementCallbackFn(AGR.signParams);
	}else{
		if(!AGR.agreementCallbackFn(AGR.signParams)){
			displayView.goBack();
		}
	}
};

//资管产品协议获取方法
AGR.showProtocolsForFundCode=function(APP_bizUnitId,fund_code) {
	AGR.bizUnitId=APP_bizUnitId;
	AGR.skipProtocols=false;
	App.showPreloader();
	$$.ajax({
		url: '/queryAgreement.do?rnd=' + new Date().getTime(),
		method: 'POST',
		data: {fund_code:fund_code,showDoc:'1'},
		success: function (data) {
			App.hidePreloader();
			if(data === 'no login'){
				App.loginScreen();
			}else{
				var dataObj = JSON.parse(data);
				if (dataObj.errorNo == '0') {//已登录
			    	if(dataObj==null){
			    		App.hidePreloader();
			    		App.alert("无相关协议");
			    		return;
			    	}
			    	AGR.isSign=false;
					AGR.data=dataObj;
					AGR.protocols=dataObj.list;
				} else {//未登录
					App.hidePreloader();
					App.alert(dataObj.errorInfo);
				}
			}
		},
		error: function(){
			AGR.errorFun("网络连接失败");
 		},
 		timeout: function(){
			AGR.errorFun("网络连接失败");
 		},
	});
};


AGR.errorFun=function(msg){
	App.hidePreloader();
	App.alert(msg,function(){
		if(AGR.skipProtocols==false){
			displayView.goBack();
		};
	});
};


