require.config({
	baseUrl : '../template-std/js',
	paths : {
		Framework7 : 'libs/framework7',
		text : 'libs/text',
		swiper : 'libs/swiper',
		GS : 'services/globalService',
		accountService : 'services/accountService',
		echarts : 'libs/echarts',
	},
	shim : {
		Framework7 : {
			exports : 'Framework7'
		},
		swiper : {
			exports : 'swiper'
		}
	},
//	urlArgs : "rnd=" + new Date().getTime()
});

require([ 'Framework7', 'router', 'alertDialog' ], function(Framework7, Router, alertDialog) {
	window.$$ = window.Dom7;
	var device = Framework7.prototype.device;
	localStorage.setItem('HasGoWt', "false");
	if (device.android) {
		window.App = new Framework7({
			animatePages : true,
			swipeout : false,
			sortable : true,
			cache : false,
			pushState : false,
			swipeBackPage : false,
			preloadPreviousPage : false,
			popupCloseByOutside : false,
			animateNavBackIcon : false,
			modalTitle : '温馨提示',
			modalButtonOk : '确定',
			modalButtonCancel : '取消',
			smartSelectBackText : '完成',
			smartSelectBackTemplate : '<div class="left sliding"><a href="#" class="back link"><i class="icon icon-back"></i><span>{{backText}}</span></a></div>'
		});
	} else {
		window.App = new Framework7({
			animatePages : false,
			cache : false,
			pushState : false,
			swipeBackPage : false,
			preloadPreviousPage : false,
			popupCloseByOutside : false,
			animateNavBackIcon : false,
			modalTitle : '温馨提示',
			modalButtonOk : '确定',
			modalButtonCancel : '取消',
			smartSelectBackText : '完成',
			smartSelectBackTemplate : '<div class="left sliding"><a href="#" class="back link"><i class="icon icon-back"></i><span>{{backText}}</span></a></div>'
		});
	}

    window.AppPicker = {};
	App.alertDialog = alertDialog.alertDialog;
	App.closeDialog = alertDialog.closeDialog;
	window.mainView = window.App.addView('#index', {
		dynamicNavbar : true
	});
    window.mainView.goBack = window.mainView.back;
	Router.init();
	$$.ajax({
		type : "POST",
		url : SERVICE_DOMAIN_URL + "/initParams.json?rnd=" + new Date().getTime(),
		success : function(data) {
			data = JSON.parse(data);
			isLogin = data.isLogin;
			cookieTimeout = data.cookieTimeout;// cookie超时时间
			SECURITY_ALIAS = data.security_alias;// 券商别名
			localStorage.setItem('SERVICE_DOMAIN_URL', SERVICE_DOMAIN_URL);
			SERVICE_PHONE = data.service_phone;// 服务电话
            RSA_PUB_KEY = data.rsa_public_key;// 公钥
            MALL_LOGIN_PWD_DECRYPT = data.mall_login_pwd_decrypt
            FUNC_MFUND_NAME = data.func_mfund_name
			loadFirstPage();
		},
		error : function() {
			App.alert("系统异常，请稍后再试！");
		},
		timeout : timeOutFn
	});
	$$(".backend-back-btn .left").on('click', function() {
		closeSJKH();
	});

});

function loadFirstPage() {
    var loadUrl = "";
    isshowback = GetQueryString("isshowback");
    var myOrder = GetQueryString("myOrder");
    var product_no = GetQueryString("product_no");
    var fromPage = GetQueryString("fromPage");
    var indexUrl = GetQueryString("indexUrl");
    appfromPage = fromPage;
    ISFIRST = myOrder;
    var haslogin = 'false';
	if (myOrder == 'myOrder') {
		loadUrl = SERVICE_DOMAIN_URL + "/goMyOrderNew.htm?fromPage=app";
	} else if (myOrder == 'detail' && product_no.length > 0) {
		loadUrl = "../template-std/page/prodetail/product-detail-all.html?product_no=" + product_no + "&fromPage=app";
	} else if (myOrder == 'current') {
		loadUrl = "../template-hazq/page/product-list.html?category_id=10009&title=活期产品列表&fromPage=app";
	} else if (myOrder == 'dingqi') {
		loadUrl = "../template-hazq/page/product-list.html?category_id=10008&title=定期产品列表&fromPage=app";
	} else if (myOrder == 'xinshou') {
		loadUrl = "../template-hazq/page/fresh-financing/home.html?fromPage=app";
	} else if (myOrder == 'xstopic') {
		loadUrl = "../template-std/page/fund-area.html?topic_no=20000&fromPage=app";
	} else if (myOrder == 'hqb') {
		loadUrl = "func_mfund/goFuncMFundIndex.htm";
	}else if (myOrder == 'local'||myOrder=='app'){
        loadUrl = decodeURI(indexUrl);
        haslogin = GetQueryString2(loadUrl,'haslogin');
        appfromPage = 'newapp';
        ISFIRST = myOrder;
	} else if (myOrder == 'net'){
        loadUrl = decodeURI(indexUrl);
        appfromPage = 'newapp';
        ISFIRST = 'net';
    }
   	if (localStorage.getItem('loginDone') == "false") {
		APP_params.loginAfterCallBack = "";
	}

	if (myOrder == 'myOrder' && isLogin == "false") {
		localStorage.setItem("from", "order");
		doLogin();
        APP_params.login_from_url = loadUrl;
        localStorage.setItem("toUrl", loadUrl);
	} else if (loadUrl == "/goPersonalCerter.do" && isLogin == "false") {
		localStorage.setItem("from", "personal");
		doLogin();
        APP_params.login_from_url = loadUrl;
        localStorage.setItem("toUrl", loadUrl);
	} else if (loadUrl.length > 0) {
		if(haslogin == 'true' && isLogin == 'false'&& appfromPage == 'newapp'){
            doLogin();
            APP_params.login_from_url = loadUrl;
            localStorage.setItem("toUrl", loadUrl);
		}else{
	    	mainView.reloadPage(loadUrl);
        }
	} else {
		if(fromPage == "newapp"&&SECURITY_ALIAS == 'xsdzq'){
			try{
                registerJsEventTag();
			}catch (e){

			}
            APP_params.loginAfterCallBack = function () {
                mainView.loadPage(SERVICE_DOMAIN_URL + "../template-xsdzq/page/index-login-app.html");
            };
            APP_params.endAfterCallBack = function () {
                mainView.loadPage(SERVICE_DOMAIN_URL + "../template-xsdzq/page/index-login-app.html");
            };
            doAppLogin();
		}else{
            if (SECURITY_ALIAS == 'xsdzq') {
                mainView.loadPage("../template-xsdzq/page/index-login.html");
            }else if (SECURITY_ALIAS == 'hazq') {
                mainView.loadPage("../template-hazq/page/index-login.html");
            } else {
                mainView.loadPage("../template-std/page/index-login.html");
            }
		}
	}

}

// 获取浏览器后面的参数
function GetQueryString(name) {
	var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)");
	var r = window.location.search.substr(1).match(reg);
	if (r != null)
		return unescape(r[2]);
	return null;
}

// 获取浏览器后面的参数
function GetQueryString2(url,name) {
    var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)");
    var r = url.match(reg);
    if (r != null)
        return unescape(r[2]);
    return null;
}