define([], function () {
    var PasswordKeyboard = function (conTarget, callback, passwordLength) {
        this.conTarget = conTarget,
        this.callback = callback,
        this.passwordLength = passwordLength;
        this.init();
    };
    PasswordKeyboard.prototype = {
        init: function () {
            this.conTarget.html('');
            this.conTarget.append(this.keyboardInput() + this.keyboard());
            this.inputValue();
            this.deleteValue();
            this.passwordConfirm();
        },
        keyboard: function () {
            var keyboard = '<div class="password-keyboard">'
                + '<div class="keyboard-con row">'
                + '<div class="keyboard-value">'
                + '<div data-value="1">1</div>'
                + '<div data-value="2">2</div>'
                + '<div data-value="3">3</div>'
                + '<div data-value="4">4</div>'
                + '<div data-value="5">5</div>'
                + '<div data-value="6">6</div>'
                + '<div data-value="7">7</div>'
                + '<div data-value="8">8</div>'
                + '<div data-value="9">9</div>'
                + '<div></div>'
                + '<div data-value="0">0</div>'
                + '<div></div>'
                + '</div>'
                + '<div class="keyboard-operate">'
                + '<div data-operate="delete" class="keyboard-delete"></div>'
                + '<div data-operate="confirm" class="keyboard-confirm">完成</div>'
                + '</div>'
                + '</div>'
                + '</div>';
            return keyboard;
        },
        keyboardInput: function () {
            var input = '<div class="password-block"><input type="password" class="password-input" id="picker_password" maxlength="' + this.passwordLength + '">';
            for (var i = 0; i < this.passwordLength; i++) {
                input += '<div></div>';
            }
            input += '</div>';
            return input
        },
        inputValue: function () {
            var _this = this;
            _this.conTarget.find('.keyboard-value>div').click(function () {
                if (_this.conTarget.find('.password-input').val().length >= _this.passwordLength || !this.getAttribute('data-value')) {
                    return false
                }
                _this.conTarget.find('.password-input').val(_this.conTarget.find('.password-input').val() + $$(this).attr('data-value'));
                _this.updateValue();
            })
        },
        deleteValue: function () {
            var _this = this;
            _this.conTarget.find('.keyboard-delete').click(function () {
                _this.conTarget.find('.password-input').val(_this.conTarget.find('.password-input').val().substring(0, _this.conTarget.find('.password-input').val().length - 1));
                _this.updateValue();
            })
        },
        updateValue: function () {
            this.conTarget.find('.password-block>div').removeClass('active');
            for (var i = 0; i < this.conTarget.find('.password-input').val().length; i++) {
                this.conTarget.find('.password-block>div')[i].className = 'active';
            }
        },
        passwordConfirm: function () {
            var _this = this;
            _this.conTarget.find('.keyboard-confirm').click(function () {
                if (_this.conTarget.find('.password-input').val().length == _this.passwordLength) {
                    _this.callback();
                }
            })
        },
        passwordClear: function () {
            this.conTarget.find('.password-block>div').removeClass('active');
            this.conTarget.find('.password-input').val('');
        }
    }

    function passwordKeyboard(conTarget, callback, passwordLength) {
        return new PasswordKeyboard(conTarget, callback, passwordLength);
    }

    return {
        passwordKeyboard: passwordKeyboard
    }
});