define([], function () {
  /**
   * 弹窗密码组件，可接受一个参数
   * @param  {string} url 密码正确后要跳转的url
   * @return {function} popupPassword
   * @author yuanqi@cairenhui.com
   */
  function popupPassword(url) {
    var pas = document.getElementById('password-view').getElementsByTagName('span'),
    cancel = document.querySelector('.iconfont-guanbi');

    function passInput() {
      $$('#password').focus().val('');
      getPosition();
      $$('#password')[0].oninput = function () {
        var length = this.value.length;
        for (var i = pas.length - 1; i >= 0; i--) {
          pas[i].className = '';
        }
        for (var j = length - 1; j >= 0; j--) {
          pas[j].className = 'active';
        }
      }
    }

    function passCancel() {
      $$(cancel).click(function () {
        console.log('cancel');
        App.closeModal('.popup-password');
        // doSomeThing when cancel has been click
      });
    }

    function passEnter(url) {
      $$('#password').on('input', function () {
        var password = $$('#password').val();
        if (password.length === 6) {
          console.log(password);
          $$('#password').blur();
          App.closeModal('.popup-password');
          checkPassword(url, password);
        }
      });
      $$('#password').on('blur', function () {
        if (!Framework7.prototype.device.android) {
          $$('.password-dialog').css({
            'top': '0',
            'bottom': '0'
          })
        }
      })
    }

    function checkPassword(url, password) {
      var loadingStr = '<i class="iconfont iconfont-loading"></i>' +
        '<br/>' +
        '<div>正在校验</div>';
      var successStr = '<i class="iconfont iconfont-chenggongtishi"></i>' +
        '<br/>' +
        '<div>付款成功</div>';

      App.alertDialog(loadingStr);

      $$.ajax({
        url: 'api/password.json',
        type: 'GET',
        data: password,
        success: function (data) {
          data = JSON.parse(data);
          App.closeDialog();
          if (data.errorNo === 0) {
            App.alertDialog(successStr);
            App.closeModal();
            setTimeout(function () {
              App.closeDialog();
              mainView.loadPage(url);
            }, 1000);
          } else {
            //doSomething
          }
        }
      });
    }

    function getPosition() {
      var pas = $$('.popup-password');
      if (!Framework7.prototype.device.android) {
        $$('.password-dialog').css({
          'top': 'initial',
          'bottom': '10px'
        })
      }
    }
    
    function closeDialog() {
        var closeBtn = $$('.popup-password .iconfont-guanbi');
        closeBtn.click(function () {
          App.closeModal('.popup-password');
        })
      }

    passInput();
    passCancel();
    passEnter(url);
    closeDialog();
  }

  return {
    popupPassword: popupPassword
  }
});
