define([ 'libs/echarts/chart/echarts3', 'http' ], function(Echarts, Http) {
	var binddings = [ {
		target : '.chart-tab',
		element : '.chart-tab .tab',
		event : 'click',
		handler : switchTab
	}, {
		target : '.chart-part',
		element : '.js-switch-chart .button',
		event : 'click',
		handler : switchTabTime
	}, {
		element : '.product-detail',
		event : 'click',
		handler : function() {
			myChart.dispatchAction({
				type : 'hideTip'
			})
		}
	}, {
		element : '#productChart',
		event : 'click',
		handler : function(e) {
			e.stopPropagation();
		}
	} ];
	var initParams = {};
	var chart_column = "nav_ratio";
	var chart_period_month = "1";
	var product_no = '';
	var init_date = '';
	var cat_varieties = '';
	var myChart = null;
	var chartData = {};// 切换图表
	chartData.date = [];// 横坐标：时间
	chartData.mfund_year_rate = [];// 7日年化收益率
    chartData.income_unit = [];// 万份收益
	chartData.unit_net_value = [];// 单位净值
	chartData.total_net_value = [];// 累计净值
	chartData.nav_ratio = [];// 日涨幅
	chartData.month_ratio = [];// 月涨幅
	chartData.hs300_ratio = [];// 沪深300涨幅
	var laster_nav_ratio = 0;
	var laster_quote_ratio = 0;
	var riseWidthMap = {};
	function init(show_product_no, init_date_str, show_cat_varieties, show_chart_period_month, callback, params) {
		initParams = params;
		riseWidthMap = {};
		product_no = show_product_no;
		init_date = init_date_str;
		chartData.date = [];// 横坐标：时间
		chartData.mfund_year_rate = [];// 7日年化收益率
        chartData.income_unit = [];// 万份收益
		chartData.unit_net_value = [];// 单位净值
		chartData.total_net_value = [];// 累计净值
		chartData.nav_ratio = [];// 日涨幅
		chartData.hs300_ratio = [];// 沪深300涨幅
		myChart = null;
		if (typeof show_chart_period_month != "undefined") {
			chart_period_month = show_chart_period_month;
		}
		cat_varieties = show_cat_varieties;
		if (show_cat_varieties === '5' || show_cat_varieties === '12') {
			chart_column = "mfund_year_rate";// 货币型，短期理财展示 七日年化收益率
		} else {
			chart_column = "month_ratio";
			// chart_column = "nav_ratio";//日涨幅
		}
		chartData.date[chart_period_month] = [];// 横坐标：时间
		chartData.mfund_year_rate[chart_period_month] = [];// 7日年化收益率
        chartData.income_unit[chart_period_month] = [];// 万份收益
		chartData.unit_net_value[chart_period_month] = [];// 单位净值
		chartData.total_net_value[chart_period_month] = [];// 累计净值
		chartData.nav_ratio[chart_period_month] = [];// 日涨幅
		chartData.month_ratio[chart_period_month] = [];// 月涨幅
		chartData.hs300_ratio[chart_period_month] = [];// 沪深300涨幅
		switchChart(callback);
	}

	// 切换单位净值，累计净值，累计收益
	function switchTab() {
		chart_column = $$(this).data('column');
		$$('.chart-tab .tab').removeClass('active');
		$$(this).addClass('active');
		if ($$(this).attr('opt') === 'profit') {
			$$('.chart-sign').removeClass('hide');
		} else {
			$$('.chart-sign').addClass('hide');
		}
		switchChart();
	}

	// 切换月份 1个月 3个月 6个月 1年
	function switchTabTime() {
		chart_period_month = $$(this).data('period');
		$$('.js-switch-chart .button').removeClass('active');
		$$(this).addClass('active');
		switchChart();
	}

	function switchChart(callback) {
		if (typeof chartData.date[chart_period_month] === "undefined" || chartData.date[chart_period_month].length === 0) {
			chartData.date[chart_period_month] = [];// 横坐标：时间
			chartData.mfund_year_rate[chart_period_month] = [];// 7日年化收益率
            chartData.income_unit[chart_period_month] = [];// 万份收益
			chartData.unit_net_value[chart_period_month] = [];// 单位净值
			chartData.total_net_value[chart_period_month] = [];// 累计净值
			chartData.nav_ratio[chart_period_month] = [];// 日涨幅
			chartData.month_ratio[chart_period_month] = [];// 月涨幅
			chartData.hs300_ratio[chart_period_month] = [];// 沪深300涨幅
			// 根据实际情况更改下面的 url
			var params = {
				"product_no" : product_no,
				"init_date" : init_date,
				"month" : chart_period_month
			};
			Http.post("prohisnav/getProdHis.do", params, false).then(function(data) {
				for (var i = 0; i < data.resultList.length; i++) {
					chartData.mfund_year_rate[chart_period_month].push(data.resultList[i].seven_income_ratio);// 7日年化收益率
                    chartData.income_unit[chart_period_month].push(Number(data.resultList[i].income_unit));// 万份收益
					chartData.unit_net_value[chart_period_month].push(data.resultList[i].unit_net_value);// 单位净值
					chartData.total_net_value[chart_period_month].push(data.resultList[i].total_net_value);// 累计净值
					chartData.nav_ratio[chart_period_month].push(data.resultList[i].income_ratio);// 日涨幅
					if (chart_column != "month_ratio") {
						chartData.date[chart_period_month].push(data.resultList[i].init_date);// 横坐标：时间
					} else {
						laster_quote_ratio = data.resultList[i].quote_ratio;
						if ((data.resultList[i].quote_ratio || "") != "") {
							if ((data.resultList[i].month_profit || "") != "" && chart_period_month == "1") {
								chartData.date[chart_period_month].push(data.resultList[i].init_date);// 横坐标：时间
								chartData.month_ratio[chart_period_month].push(data.resultList[i].month_profit);// 月涨幅
								chartData.hs300_ratio[chart_period_month].push(data.resultList[i].quote_ratio);// 沪深300涨幅
								laster_nav_ratio = data.resultList[i].month_profit;
							}
							if ((data.resultList[i].month3_profit || "") != "" && chart_period_month == "3") {
								chartData.date[chart_period_month].push(data.resultList[i].init_date);// 横坐标：时间
								chartData.month_ratio[chart_period_month].push(data.resultList[i].month3_profit);// 月涨幅
								chartData.hs300_ratio[chart_period_month].push(data.resultList[i].quote_ratio);// 沪深300涨幅
								laster_nav_ratio = data.resultList[i].month3_profit;
							}
							if ((data.resultList[i].month6_profit || "") != "" && chart_period_month == "6") {
								chartData.date[chart_period_month].push(data.resultList[i].init_date);// 横坐标：时间
								chartData.month_ratio[chart_period_month].push(data.resultList[i].month6_profit);// 月涨幅
								chartData.hs300_ratio[chart_period_month].push(data.resultList[i].quote_ratio);// 沪深300涨幅
								laster_nav_ratio = data.resultList[i].month6_profit;
							}
							if ((data.resultList[i].year_profit || "") != "" && chart_period_month == "12") {
								chartData.date[chart_period_month].push(data.resultList[i].init_date);// 横坐标：时间
								chartData.month_ratio[chart_period_month].push(data.resultList[i].year_profit);// 月涨幅
								chartData.hs300_ratio[chart_period_month].push(data.resultList[i].quote_ratio);// 沪深300涨幅
								laster_nav_ratio = data.resultList[i].year_profit;
							}
						}
					}
					riseWidthMap['month' + chart_period_month] = laster_nav_ratio;
					riseWidthMap['hs300' + chart_period_month] = laster_quote_ratio;
					laster_nav_ratio = data.resultList[i].income_ratio + "%";
				}
				callback && callback({
					cat_varieties : cat_varieties
				}, binddings);
				randerChart();
				if(data.nodata == 'true'){
                  $$(".echatTab").hide();
                  $$(".chart-part").hide();
				}
				lasterRatioShow(laster_nav_ratio, laster_quote_ratio);
			}, function(msg) {
				App.alert(showErrorMsg(msg));
			});
		} else {
			callback && callback({}, binddings);
			randerChart();
			lasterRatioShow(laster_nav_ratio, laster_quote_ratio);
		}
	}

	function randerChart() {
		changeSeries();
		var option = optionGenerator();
		myChart = Echarts.init(document.getElementById('productChart'));
		myChart.setOption(option);
	}

	var yAxis_name = "";
	var series = [];
	function changeSeries() {
		if (chart_column == "mfund_year_rate") {
			series = [ {
				name : '七日年化(%)',
				type : 'line',
				symbol : 'emptyCircle',
				smooth : false,
				symbolSize : 1,
				data : chartData.mfund_year_rate[chart_period_month]
			} ];
			yAxis_name = "七日年化(%)";
		} else if (chart_column == "income_unit") {
            series = [ {
                name : '万份收益',
                type : 'line',
                smooth : false,
                symbol : 'emptyCircle',
                symbolSize : 1,
                data : chartData.income_unit[chart_period_month]
            } ];
            yAxis_name = "万份收益";
        } else if (chart_column == "unit_net_value") {
			series = [ {
				name : '单位净值',
				type : 'line',
				smooth : false,
				symbol : 'emptyCircle',
				symbolSize : 1,
				data : chartData.unit_net_value[chart_period_month]
			} ];
			yAxis_name = "单位净值";
		} else if (chart_column == "total_net_value") {
			series = [ {
				name : '累计净值',
				type : 'line',
				smooth : false,
				symbol : 'emptyCircle',
				symbolSize : 1,
				data : chartData.total_net_value[chart_period_month]
			} ];
			yAxis_name = "累计净值";
		} else {
			if (chart_period_month == "1") {
				$$(".fundratiotext").text("月涨跌幅");
			} else if (chart_period_month == "3") {
				$$(".fundratiotext").text("季涨跌幅");
			} else if (chart_period_month == "6") {
				$$(".fundratiotext").text("半年涨跌幅");
			} else if (chart_period_month == "12") {
				$$(".fundratiotext").text("年涨跌幅");
			}
			var seriesData = chartData.month_ratio[chart_period_month];
			laster_quote_ratio = riseWidthMap['hs300' + chart_period_month];
			if (SECURITY_ALIAS == "hazq"||initParams.category_id=='10014'||initParams.category_id=='10015') {
				laster_nav_ratio = riseWidthMap['month' + chart_period_month]+'%';
			} else {
				if (chart_period_month == "1") {
					laster_nav_ratio = initParams.show_month_ratio;
				} else if (chart_period_month == "3") {
					laster_nav_ratio = initParams.show_month3_ratio;
				} else if (chart_period_month == "6") {
					laster_nav_ratio = initParams.show_month6_ratio;
				} else if (chart_period_month == "12") {
					laster_nav_ratio = initParams.show_year_ratio;
				}
			}
			series = [ {
				name : '本基金涨跌(%)',
				type : 'line',
				symbol : 'emptyCircle',
				symbolSize : 1,
				smooth : false,
				data : seriesData
			}, {
				name : '沪深300涨跌(%)',
				type : 'line',
				smooth : false,
				symbol : 'emptyCircle',
				symbolSize : 1,
				lineStyle : {
					normal : {
						width : 1
					}
				},
				data : chartData.hs300_ratio[chart_period_month]
			} ];
			yAxis_name = "涨跌幅(%)";
		}
	}
	// 生成图表配置
	function optionGenerator() {
		var show_date = [];
		for (var i = 0; i < chartData.date[chart_period_month].length; i++) {
			var temp = chartData.date[chart_period_month][i];
			// if (temp.indexOf("0101") == -1) {
			// 	show_date.push(temp.substr(4, 2) + "/" + temp.substr(6, 2))
			// } else {
				show_date.push(temp.substr(0, 4) + "/" + temp.substr(4, 2) + "/" + temp.substr(6, 2))
			//}
		}
		// 防止走势图触底
		var dataArrey = [];
		if (chart_column == "mfund_year_rate") {
			dataArrey = dataArrey.concat(chartData.mfund_year_rate[chart_period_month]);
		} else if (chart_column == "income_unit") {
            dataArrey = dataArrey.concat(chartData.income_unit[chart_period_month]);
        } else if (chart_column == "unit_net_value") {
			dataArrey = dataArrey.concat(chartData.unit_net_value[chart_period_month]);
		} else if (chart_column == "total_net_value") {
			dataArrey = dataArrey.concat(chartData.total_net_value[chart_period_month]);
		} else {
			dataArrey = dataArrey.concat(chartData.hs300_ratio[chart_period_month]).concat(chartData.month_ratio[chart_period_month]);
		}
		var mindata = dataArrey[0];
		maxdata = dataArrey[0];
		for (var i = 0; i < dataArrey.length; i++) {
			maxdata = Math.max(maxdata, dataArrey[i]) || 0;
			mindata = Math.min(mindata, dataArrey[i]) || 0;
		}
		mindata -= (maxdata - mindata) / 4;
		var option = {
			color : [ '#fb5b4c', '#3ea5ff' ],
			grid : {
				x : '50',
				x2 : '30',
				y : '30',
				y2 : '30',
				borderWidth : 0
			},
			animation : false,
			tooltip : {
				trigger : 'axis',
				backgroundColor : '#fb5b4c',
				formatter : function(e) {
					if (chart_column == "nav_ratio" || chart_column == "month_ratio") {
						var returnStr = e[0].name + '<br/>';
						returnStr += e[0].seriesName + ':&nbsp;' + e[0].value + '<br/>';
						returnStr += e[1].seriesName + ':&nbsp;' + e[1].value + '<br/>';
						return returnStr;
					} else {
						return e[0].name + '<br/>' + e[0].seriesName + ':&nbsp;' + e[0].value + '<br/>';
					}
				},
				axisPointer : {
					type : 'line',
					lineStyle : {
						color : '#FFD43C',
						type : 'dashed',
						width : 1
					},
					crossStyle : {
						color : '#FFD43C'
					}
				}
			},
			xAxis : [ {
				axisTick : false,
				type : 'category',
				axisLabel : {
					textStyle : {
						color : '#c8c7cc'
					},
                    interval: function(i) {
						return (i === 0 || i === (show_date.length - 1) || i === Math.floor(show_date.length / 2));
					}
				},
				axisLine : {
					lineStyle : {
						color : '#F7F7F7',
						width : 1
					}
				},
				splitLine : {
					show : false,
					lineStyle : {
						color : '#F7F7F7'
					}
				},
				boundaryGap : false,
				data : show_date
			} ],
			yAxis : [ {
				name : yAxis_name,
				nameLocation : 'end',
				nameTextStyle : {
					color : '#FCAD48',
					align : 'left',
					baseline : 'bottom'
				},
				type : 'value',
				scale : true,
				min : mindata,
				axisLabel : {
					margin : 10,
					formatter : function(value) {
						return (Number(value)).toFixed(2)
					},
					textStyle : {
						color : '#c8c7cc'
					}
				},
				axisTick : {
					show : false
				},
				axisLine : {
					show : false
				},
				splitLine : {
					lineStyle : {
						color : '#f7f7f7'
					}
				}
			} ],
			series : series
		};

		if (navigator.userAgent.indexOf('SAMSUNG') === -1) {
			option.animation = true;
		}
		return option;
	}
	function lasterRatioShow(laster_nav_ratio, laster_quote_ratio) {
		if (chart_column == "nav_ratio" || chart_column == "month_ratio") {
			$$('#laster_nav_ratio').text((laster_nav_ratio || "--") );
			$$('#laster_quote_ratio').text((laster_quote_ratio || "--") + "%");
			if (parseFloat(laster_nav_ratio) > 0) {
				$$('#laster_nav_ratio').css({
					color : 'red'
				});
			} else if (parseFloat(laster_nav_ratio) < 0) {
				$$('#laster_nav_ratio').css({
					color : 'green'
				});
			} else {
				$$('#laster_nav_ratio').css({
					color : 'gray'
				});
			}
			if (Number(laster_quote_ratio) > 0) {
				$$('#laster_quote_ratio').css({
					color : 'red'
				});
			} else if (Number(laster_quote_ratio) < 0) {
				$$('#laster_quote_ratio').css({
					color : 'green'
				});
			} else {
				$$('#laster_quote_ratio').css({
					color : 'gray'
				});
			}
		}
	}
	return {
		switchChart : switchChart,
		binddings : binddings,
		init : init
	}
});
