define(['GS','template'], function(GS,Template) {
	
    /**
     * Init router, that handle page events
     */
    function init() {
        Template.register();
        $$(document).on('pageBeforeInit', function(e) {
            var page = e.detail.page;
            load(page.name, page.query);
        });
    }
    
  
    /**
     * Load (or reload) controller from js code (another controller) - call it's init function
     * @param  controllerName
     * @param  query
     */
    function load(controllerName, query) {
        if (!controllerName) {
            return;
        }
        if (controllerName.indexOf('smart-select') !== -1) {
            return;
        }
        require([SERVICE_DOMAIN_URL + '/template-std/js/controllers/' + controllerName + 'Controller.js'+'?rnd=' + new Date().getTime()], function(controller) {
            controller.init(query);
        });
    }

    return {
        init: init,
        load: load
    };
});
