define([ 'utils' ], function(Utils) {
	function render(selector, data) {
		var template = $$('script' + selector);
		var templateStr = template.html();
		var parent = template.parent();
		var compiledTemplate = Template7.compile(templateStr);

		parent.append(compiledTemplate(data));
	}

	function register() {
		/* eslint-disable */
		window.Template7.registerHelper('compare', function(expression, options) {
			var func;
			if (expression.indexOf('return') >= 0) {
				func = '(function(){' + expression + '})';
			} else {
				func = '(function(){return (' + expression + ')})';
			}
			var context = Utils.merge(this, options.data);
			var condition = eval.call(context, func).call(context);
			if (condition) {
				return options.fn(this, options.data);
			} else {
				return options.inverse(this, options.data);
			}
		});
		/* eslint-enable */
        /**
         * value 需要年月日 格式
         * 显示[年月日]
         */
        window.Template7.registerHelper('yyyyMMdd', function (value, options) {
            return yyyyMMdd(value);
        });
        window.Template7.registerHelper('payCycle', function (pay_cycle_unit,pay_cycle_rate,en_fund_date, options) {
            return payCycle(pay_cycle_unit,pay_cycle_rate,en_fund_date);
        });
        window.Template7.registerHelper('valueType', function(value,num,options) {
            return valueType(value,num);
        });
        window.Template7.registerHelper('numStrToChar', function(value,options) {
            return numStrToChar(value);
        });
        window.Template7.registerHelper('fmoney', function(value,num,options) {
            return fmoney(value,num);
        });
        //显示月-日
        window.Template7.registerHelper('MMdd', function (value,type, options) {
            return MMdd(value,type);
        });
	}
    function MMdd(value,type){
        if(value&&value.replace(/-/g,"").trim().length==8){
            value = value.replace(/-/g,"").trim();
            value = value.substr(0,4)+"/"+value.substr(4,2)+"/"+value.substr(6,2)
            var date = new Date(value);

            if(type == "1"){
                var month = (date.getMonth() + 1).toString().length == 1 ?"0"+(date.getMonth() + 1):(date.getMonth() + 1);
                var day = date.getDate().toString().length == 1 ?"0"+date.getDate():date.getDate();
                return month+"-"+day;
            }
            if(type == "2"){
                var month = date.getMonth() + 1;
                var day = date.getDate();
                return month+"月"+day+"日";
            }

        }else{
            return value;
        }
    }
    function payCycle(pay_cycle_unit,pay_cycle_rate,en_fund_date){
    	if(pay_cycle_unit == '0'){
    	    if (en_fund_date.length == 1){
                en_fund_date = "0" + en_fund_date;
            }
            return  "每月" + en_fund_date +"日";
		}else if(pay_cycle_unit == '2'){
             return "每日";
        }else{
		    if(pay_cycle_rate == '1'){
               return "每周" +  switchWeek(en_fund_date);
            }else{
                return "每两周" +  switchWeek(en_fund_date);
            }
            return value;
        }
	}
	function switchWeek(en_fund_date) {
        switch (en_fund_date){
            case "1" : return "周一";
            case "2" : return "周二";
            case "3" : return "周三";
            case "4" : return "周四";
            case "5" : return "周五";
        }
    }
    function yyyyMMdd(value){
        if(value.length==8){
            value = value.substr(0,4)+"/"+value.substr(4,2)+"/"+value.substr(6,2)
            var date = new Date(value);
            var month = (date.getMonth() + 1).toString().length == 1 ?"0"+(date.getMonth() + 1):(date.getMonth() + 1);
            var day = date.getDate().toString().length == 1 ?"0"+date.getDate():date.getDate();
            return date.getFullYear() + "-"+ month +"-"+ day;
        }else if(value == '0'){
            return "--";
        }else{
            return value;
        }
    }

    function valueType(x,num) {
        x = parseFloat(x);
        var str = x.toString();
        return toFixed(str,num);
    }
    function numStrToChar(num){
        return String.fromCharCode(parseInt(num)+65);
	}
    function fmoney(s, n)
    {
        s=Number(s);
        var head = "";
        if(s<0){
            s = Math.abs(s);
            head = "-";
        }
        n = n > 0 && n <= 20 ? n : 2;
        var dian = (s + "").indexOf('.');
        s = parseFloat((s + "").replace(/[^\d\.-]/g, ""));
        if(dian == -1){
            s = s.toFixed(n) + "";
        }else{
            var cc = (s + "").substring(dian+1,(s + "").length);
            // if(cc.length >=3){
            //     s =  (s + "").substring(0,dian+n+1);
            // }else{
                s = s.toFixed(n) + "";
           // }
        }

        var l = s.split(".")[0].split("").reverse(),
            r = s.split(".")[1];
        t = "";
        for(i = 0; i < l.length; i ++ )
        {
            t += l[i] + ((i + 1) % 3 == 0 && (i + 1) != l.length ? "," : "");
        }
        var result = t.split("").reverse().join("") + "." + r
        return head+result;
    }
    function toFixed(x,num) {
        var index = x.indexOf('.');
        if (index < 0) {
            //无小数点，自动补上.00；
            // index = x.length;
            x += '.';
            for(var i=0;i<num;i++) {
                x += '0';
            }
        }else {

            var x_a = x.substr(0, index+1);
            var x_b = x.substr(index+1);
            x = x_a;
            for(var i=0;i<num;i++) {
            	if(x_b.charAt(i)){
                    x += x_b.charAt(i);
				}else{
                    x += '0';
				}

            }
        }
        return x;
    }
	//获取浏览器参数 避免中文乱码
	function getRequest() {
	  var url = window.location.search; //获取url中"?"符后的字串
	  var theRequest = new Object();
	  if (url.indexOf("?") != -1) {
	    var str = url.substr(1);
	    strs = str.split("&");
	    for (var i = 0; i < strs.length; i++) {
	      //就是这句的问题
	      theRequest[strs[i].split("=")[0]] = decodeURI(strs[i].split("=")[1]);
	      //之前用了unescape()
	      //才会出现乱码
	    }
	  }
	  return theRequest;
	}
	return {
		render : render,
		register : register,
        yyyyMMdd : yyyyMMdd,
		getRequest : getRequest,
        valueType : valueType,
        numStrToChar : numStrToChar,
        fmoney : fmoney,
        MMdd :MMdd,
        payCycle:payCycle
	};
});
