define([ 'utils', 'text!tpl/prodetail/prodchart.html', 'text!tpl/prodetail/readme.html', 'prodchart' ], function(Utils, ProdChartTemplate, ReadmeTemplate, Prodchart) {

	function getReturnDate(expire_date) {
		var time = Date.parse(expire_date.substr(4, 2) + "/" + expire_date.substr(6, 2) + "/" + expire_date.substr(0, 4));
		var date = new Date(time + 2 * 1000 * 60 * 60 * 24);
		var month_str = (date.getMonth() + 1) < 10 ? "0" + (date.getMonth() + 1) : (date.getMonth() + 1);
		var day_str = date.getDate() < 10 ? "0" + date.getDate() : date.getDate();
		return date.getFullYear() + "" + month_str + "" + day_str;
	}
	function validateNumberDate(date) {
		return !!(typeof date !== "undefined" && date.length >= 8);
	}
	function formateNumberDate(date, showyear) {
		if (validateNumberDate(date)) {
			return (showyear ? (date.substr(0, 4) + "-") : "") + date.substr(4, 2) + "-" + date.substr(6, 2);
		} else {
			return "--";
		}
	}
	function isSameAndCurrentYear(date1, date2, date3, date4) {
		var year1 = Number(date1.substr(0, 4));
		var year2 = Number(date2.substr(0, 4));
		var year3 = Number(date3.substr(0, 4));
		var year4 = Number(date4.substr(0, 4));
		if (year1 === year2 && year2 === year3 && year3 === year4) {
			var date = new Date();
			return date.getFullYear() == year1;
		} else {
			return false;
		}
	}

	// 加载产品详情顶部
	function renderTop(params, bindings) {
		var topparams = {
			product_no : params.product_no,
			init_date : params.init_date,
			init_date_str : params.init_date_str,
			min_tendtendered_sum_str : typeof params.min_tendtendered_sum_str === "undefined" ? "--" : params.min_tendtendered_sum_str.replace("起购", ""),
			risk_name : typeof params.risk_name === "undefined" ? "--" : params.risk_name
		};
        topparams.SECURITY_ALIAS=SECURITY_ALIAS;
		if (params.cat_varieties == "5" || params.cat_varieties == "12") {// 5:货币型
			// 12:短期理财
			  if(SECURITY_ALIAS == "xsdzq"&& params.fund_code.toLowerCase() == "czz") {
                  topparams.text1 = "业绩比较基准（年化）";
              }else{
                  topparams.text1 = "七日年化收益率";

			  }
			topparams.textValue1 = typeof params.mfund_year_rate === "undefined" ? "--" : params.show_mfund_year_rate.replace("%", "");
			topparams.textValue1_after = "%";
			topparams.textColumn1 = "mfund_year_rate";
			topparams.text2 = "万份收益";
			topparams.textValue2 = typeof params.income_unit === "undefined" ? "--" : params.income_unit;
			topparams.textColumn2 = "income_unit";
		} else if (params.cat_varieties == "13" || params.cat_varieties == "17") { // 债券型分级A
			// 债券型类固定收益
			topparams.text1 = "业绩比较基准（年化）";
			if (SECURITY_ALIAS == "hazq") {
				topparams.text1 = "年化业绩比较基准";
			}
			topparams.textValue1 = typeof params.reward_ratio === "undefined" ? "--" : params.show_reward_ratio.replace("%", "");
			topparams.textColumn1 = "";
			topparams.textValue1_after = "%";
			topparams.text2 = "累计净值";
			topparams.textValue2 = typeof params.total_net_value === "undefined" ? "--" : params.total_net_value;
			topparams.textColumn2 = "total_net_value";
		} else {
			topparams.text1 = "单位净值";
			topparams.textValue1 = typeof params.unit_net_value === "undefined" ? "--" : parseFloat(params.unit_net_value).toFixed(4);
			topparams.textValue1_after = "";
			topparams.textColumn1 = "unit_net_value";
			topparams.text2 = "日涨跌幅";
            if ((params.category_id == "10005"||(params.category_id == '10014'&&params.product_status=='2')||(params.category_id == '10015'&&params.product_status=='2'))&&SECURITY_ALIAS == "xsdzq") { //新发无涨跌幅
                topparams.textValue2 ="--";
            }else{
                topparams.textValue2 = params.show_nav_ratio;
			}
			topparams.textColumn2 = "income_ratio";
		}
		if (params.category_id == "10008"&&SECURITY_ALIAS == "xsdzq") {
			$$("#prod_name").attr("data-hide","reminder");
		}
		if (params.category_id == "10006") {
			if (params.cat_varieties != "5") {
				topparams.text2 = "投资期限";
				topparams.textValue2 = params.prod_term || "";
				topparams.textColumn2 = "total_net_value";
				topparams.textValue2 = topparams.textValue2 != "" ? (topparams.textValue2 + "天") : "";
			}
		}
		topparams.init_date_str = "(" + params.init_date_str + ")";
		if (params.category_id == "10012" || params.category_id == "10013") {
            if(SECURITY_ALIAS == "xsdzq"&& params.fund_code.toLowerCase() == "czz") {
                topparams.text1 = "业绩比较基准（年化）";
            }else{
                topparams.text1 = "预期年化收益率";
			}
			topparams.textValue1 = params.show_period_min_income_ratio + "~" + params.show_period_max_income_ratio + "";
			topparams.textValue1_after = "";
			topparams.init_date_str = "";
		}
		if (topparams.textValue1_after == "%" && topparams.textValue1 == "--") {
			topparams.textValue1_after = "";
		}
		topparams.cat_varieties = params.cat_varieties;
		topparams.category_id = params.category_id;
		topparams.prod_term = params.prod_term;
		var template = $$('#detailTopTemplate').html();
		var compiledTemplate = Template7.compile(template);
		var renderTemplate = compiledTemplate(topparams);
		$$('#detailTopContent').html(renderTemplate);
		Utils.bindEvents(bindings);
	}
	// 加载产品详情主体
	function renderMain(params, bindings) {
		// 不为新发基金固定收益产品展示图标
		if (params.category_id != '10005' &&(params.category_id != '10014'||params.product_status!='2')&&(params.category_id != '10015'||params.product_status!='2')&& (params.income_type != '01'||SECURITY_ALIAS == "xsdzq") && params.category_id != '10012' && params.category_id != '10013') {
			Prodchart.init(params.product_no, params.init_date, params.cat_varieties, 1, renderMainTemplate, params);
		} else {
			var mainParmas = {
				init_date_str : params.init_date_str,
				// 产品特点说明
				prod_feature_desc : params.prod_feature_desc,
				cat_varieties : params.cat_varieties,
				category_id : params.category_id,
                product_status : params.product_status,
				income_type : params.income_type
			};
            mainParmas.SECURITY_ALIAS=SECURITY_ALIAS;
			if (params.category_id == '10005'||(params.category_id == '10014'&&params.product_status=='2')||(params.category_id == '10015'&&params.product_status=='2')) {// 新发基金 显示购买截至日期
				// 购买截至时间
				if (validateNumberDate(params.buy_end_date)) {
					mainParmas.buy_end_year = params.buy_end_date.substr(0, 4);
					var nowYear = new Date().getFullYear();
					if (Number(mainParmas.buy_end_year) == nowYear) {
						mainParmas.buy_end_year = "";
					}
					mainParmas.buy_end_month = params.buy_end_date.substr(4, 2);
					mainParmas.buy_end_day = params.buy_end_date.substr(6, 2);
				} else {
					mainParmas.buy_end_year = "--";
					mainParmas.buy_end_month = "--";
					mainParmas.buy_end_day = "--";
				}
				if(SECURITY_ALIAS == "xsdzq"){
                    mainParmas.buy_end_time = "15:00";
				}else{
                    mainParmas.buy_end_time = "15:20";
				}
			}
			if (params.income_type == '01' || params.category_id == '10012' || params.category_id == '10013') { // 固定收益显示理财周期
				// 理财周期
				// params.return_date_str = params.expire_date_str=="
				// "?"--":getReturnDate(params.expire_date_str);// 到帐
				// 判断理财周期是否为本年
				var isSameAndCurtYear = isSameAndCurrentYear(params.order_date_str, params.interest_date_str, params.expire_date_str, params.pre_expire_desc);
				if (params.order_date_str.trim().length == 8 && params.interest_date_str.trim().length == 8 && params.expire_date_str.trim().length == 8 && params.pre_expire_desc.trim().length == 8) {
					mainParmas.order_date_str = params.order_date_str.trim().length == 8 ? formateNumberDate(params.order_date_str.trim(), !isSameAndCurtYear) : params.order_date_str.trim();// 起购
					mainParmas.interest_date_str = params.interest_date_str.trim().length == 8 ? formateNumberDate(params.interest_date_str.trim(), !isSameAndCurtYear) : params.interest_date_str
							.trim();// 起息
					mainParmas.expire_date_str = params.expire_date_str.trim().length == 8 ? formateNumberDate(params.expire_date_str.trim(), !isSameAndCurtYear) : params.expire_date_str.trim();// 到期
					mainParmas.return_date_str = params.pre_expire_desc.trim().length == 8 ? formateNumberDate(params.pre_expire_desc.trim(), !isSameAndCurtYear) : params.pre_expire_desc.trim();// 到账
					mainParmas.init_date_str = params.init_date.trim().length == 8 ? formateNumberDate(params.init_date.trim(), !isSameAndCurtYear) : params.init_date.trim();
				} else {
					params.order_date_str = params.order_date_str || "";
					mainParmas.order_date_str = params.order_date_str.trim().length == 8 ? formateNumberDate(params.order_date_str.trim(), false) : params.order_date_str.trim();// 起购
					params.order_date_str = params.interest_date_str || "";
					mainParmas.interest_date_str = params.interest_date_str.trim().length == 8 ? formateNumberDate(params.interest_date_str.trim(), false) : params.interest_date_str.trim();// 起息
					params.order_date_str = params.expire_date_str || "";
					mainParmas.expire_date_str = params.expire_date_str.trim().length == 8 ? formateNumberDate(params.expire_date_str.trim(), false) : params.expire_date_str.trim();// 到期
					params.order_date_str = params.pre_expire_desc || "";
					mainParmas.return_date_str = params.pre_expire_desc.trim().length == 8 ? formateNumberDate(params.pre_expire_desc.trim(), false) : params.pre_expire_desc.trim();// 到账
					params.order_date_str = params.init_date || "";
					mainParmas.init_date_str = params.init_date.trim().length == 8 ? formateNumberDate(params.init_date.trim(), false) : params.init_date.trim();
				}
			}
			renderMainTemplate(mainParmas, bindings);
			if (params.income_type == '01' || params.category_id == '10012' || params.category_id == '10013') {
				if (params.init_date >= params.order_date_str) {
					$$('.product-progress .node').eq(0).addClass('active');
					var progress = 0;
					if (params.init_date < params.interest_date_str) {
						progress = ((Number(params.init_date) - Number(params.order_date_str)) / (Number(params.interest_date_str) - Number(params.order_date_str))) * 100;
						$$('.product-progress .line').eq(0).html('<div class="active-line" style="width: ' + progress + '%;"></div>');
					} else {
						$$('.product-progress .node').eq(1).addClass('active');
						$$('.product-progress .line').eq(0).html('<div class="active-line" style="width: 100%;"></div>');
						if (params.init_date < params.expire_date_str) {
							progress = ((Number(params.init_date) - Number(params.interest_date_str)) / (Number(params.expire_date_str) - Number(params.interest_date_str))) * 100;
							$$('.product-progress .line').eq(1).html('<div class="active-line" style="width: ' + progress + '%;"></div>');
						} else {
							$$('.product-progress .node').eq(2).addClass('active');
							$$('.product-progress .line').eq(1).html('<div class="active-line" style="width: 100%;"></div>');
							if (params.init_date < params.return_date_str) {
								progress = ((Number(params.init_date) - Number(params.expire_date_str)) / (Number(params.return_date_str) - Number(params.expire_date_str))) * 100;
								$$('.product-progress .line').eq(2).html('<div class="active-line" style="width: ' + progress + '%;"></div>');
							} else {
								$$('.product-progress .node').eq(3).addClass('active');
								$$('.product-progress .line').eq(2).html('<div class="active-line" style="width: 100%;"></div>');
							}
						}
					}
				}
			}
		}
	}
	function renderFastenTemplate(data, bindings) {
		$$(".center.two-line").text(data.product_name);
		$$(".page-content.other").hide();
		if (data.recom_reason == "--") {
			data.recom_reason == "";
		}
		var order_date_str = getDateStr(data.order_date_str);
		if (new Date(order_date_str) != 'Invalid Date') {
			if (new Date(order_date_str).getTime() <= new Date().getTime()) {
				data.order_date_style = "active";
			}
		}
		data.order_date_str = order_date_str;
		var date_str = getDateStr(data.interest_date_str);
		if (new Date(date_str) != 'Invalid Date') {
			if (new Date(date_str).getTime() <= new Date().getTime()) {
				data.interest_date_style = "active";
			}
		}
		data.interest_date_str = date_str;
		date_str = getDateStr(data.expire_date_str);
		if (new Date(date_str) != 'Invalid Date') {
			if (new Date(date_str).getTime() <= new Date().getTime()) {
				data.pre_expire_style = "active";
				data.prod_term_style = "active";
			}
		}
		data.expire_date_str = date_str;
		var reward_ratio = parseFloat(data.reward_ratio.trim());
		if ((reward_ratio + "") != "NaN") {
			data.reward_ratio = (reward_ratio * 100).toFixed(2) + "%";
		} else {
			data.reward_ratio = "--";
		}
		var template = $$('#fastenTemp').html();
		var compiledTemplate = Template7.compile(template);
		var renderTemplate = compiledTemplate(data);
		$$('.page-content.fasten').html(renderTemplate);
		$$(".page.product-detail").removeClass("product-detail").addClass('xsdzq-product-detail');
		$$(".page-content.fasten").show();
		$$("a.goBuy").addClass("lh48");
		$$("a.save-old").hide();
		if (parseFloat(data.rest_holder_num) == 0 || parseFloat(data.rest_quota_rate) == 0) {
			$$("a.goBuy").text("已抢光");
			$$("a.goBuy").addClass("btn-disabled").removeClass("buy");
		}
		if (data.rest_holder_num == "-" || data.rest_quota_rate == "-") {
			$$(".process-con").remove();
		}
		if (data.income_type == "05") {
			var annual_rate = parseFloat(data.annual_rate.trim());
			if ((annual_rate + "") != "NaN") {
				data.annual_rate = (annual_rate * 100).toFixed(2) + "%";
			} else {
				data.annual_rate = "--";
			}
			$$(".preview-tips").remove();
			$$(".preview-rate").text(data.annual_rate);
            if(SECURITY_ALIAS == "xsdzq"&& data.fund_code.toLowerCase() == "czz") {
                $$(".preview-text").text("业绩比较基准（年化）");
            }else{
                $$(".preview-text").text("预期年化收益率");

			}
		}
		if (data.product_status == "6" && new Date(order_date_str) != 'Invalid Date') {// 倒计时
			var datetime = (new Date(order_date_str).getTime() / 1000 - data.sysdate) + 9 * 3600;
			countDown(datetime, $$("a.goBuy"));
			sale_status = data.sale_status == "1" ? "2" : "3";
		}
		Utils.bindEvents(bindings);
	}
	var opentimer = null, curTime = 0, leftTime = 0, sale_status = "";
	function countDown(datetime, that) {
		if (opentimer) {
			clearTimeout(opentimer);
		}
		curTime++;
		leftTime = datetime - curTime;
		$$(that).html("距离开抢还有：" + getLastTimePropmt(leftTime));
		if (leftTime > 0) {
			opentimer = setTimeout(function() {
				countDown(datetime, that);
			}, 1000);
		} else {
			$$(that).removeClass("btn-disabled").addClass("buy");
			$$(that).html("立即购买");
			$$(that).attr("data-sale_status", sale_status);
		}
	}
	function renderMainTemplate(mainParmas, bindings) {
		// mainParmas.month_ratio_flag = (SECURITY_ALIAS=="hazq"?true:false);
		mainParmas.month_ratio_flag = true;
		var compiledTemplate = Template7.compile(ProdChartTemplate);
		var renderTemplate = compiledTemplate(mainParmas);
		$$('#prodchart').html(renderTemplate);
		Utils.bindEvents(bindings);
	}
	function getLastTimePropmt(datatime) {
		var propmt = "";
		var amount = 0;
		if (datatime > 3600 * 24) {
			amount = parseInt(datatime / (3600 * 24));
			datatime = datatime - amount * 3600 * 24;
			propmt += amount + "天";
		}
		if (datatime > 3600) {
			amount = parseInt(datatime / 3600);
			datatime = datatime - amount * 3600;
			propmt += amount + "时";
		}
		if (datatime > 60) {
			amount = parseInt(datatime / 60);
			datatime = datatime - amount * 60;
			propmt += amount + "分";
		}
		propmt += datatime + "秒";
		return propmt;
	}
	function getDateStr(data_str) {
		data_str = data_str.trim() || "&nbsp;";
		var return_str = data_str;
		if (data_str.length == 8) {
			return_str = data_str.substring(0, 4) + "/" + data_str.substring(4, 6) + "/" + data_str.substring(6, 8);
		} else if (data_str.length == 10) {
			return_str = data_str.replace("-", "/").replace("-", "/");
		}
		return return_str;
	}
	function getList(name, val) {
		val = (val || "").trim();
		if (val == "--" || val == "") {
		} else {
			var map = {};
			map.name = name;
			map.val = val;
			map.posi = (index_num % 2) == 0 ? "left" : 'right';// 样式
			map.wrap = (index_num % 2) == 0 ? false : true;// 是否需要换行
			index_num++;
			renderList.push(map);
		}
	}
	var renderList = new Array(), index_num = 0;
	// 加载产品买入须知
	function renderReadme(params, binddings) {
		renderList = new Array();
		index_num = 0;
		var min_tendtendered_sum_str = (params.min_tendtendered_sum_str || "--").replace("起购", "");
		if(SECURITY_ALIAS != "xsdzq"){
            getList('起购金额', min_tendtendered_sum_str);
            getList('份额确认', params.share_confirm_desc);
            //getList('追加起点', params.append_balance_str);
            getList('预计赎回到账', params.pre_paydate_desc);
            getList('分红方式', params.dividend_mode_desc);
 			getList('开放日', (params.open_date_str || "").trim());
            getList('赎回费率', params.show_prodredeem_rate == "0.00%" ? "0" : params.show_prodredeem_rate);
 		}else{
			if(params.category_id=='10005'||(params.category_id == '10014'&&params.product_status=='2')||(params.category_id == '10015'&&params.product_status=='2')){
                getList('起购金额', min_tendtendered_sum_str);
                getList('预计赎回到账', params.pre_paydate_desc+"日");
              //  getList('追加认购', params.append_balance_str);
                getList('交易状态', (params.product_status_name || "").trim());
			}else{
                getList('起购金额', min_tendtendered_sum_str);
                getList('预计赎回到账', params.pre_paydate_desc+"日");
                getList('份额确认', params.share_confirm_desc);
                //getList('追加起点', params.append_balance_str);
                getList('交易状态', (params.product_status_name || "").trim());
                if(params.category_id=='10014'||params.category_id=='10015'){
                    getList('开放日说明', (params.open_date_note || "").trim());
                }
                getList('分红方式', params.dividend_mode_desc);

			}
		}

		if (index_num > 0) {
			renderList[--index_num].wrap = false;
		}
		var rmParams = {
			income_type : params.income_type,// 收益类型（固收、浮动等）
			recom_reason : params.recom_reason,// 推荐理由
			recom_reason_flag : (params.recom_reason.trim() || "--").trim() == "--" ? false : true,// 推荐理由
			risk_profit_point : params.risk_profit_point,// 收益特征
			smallest_flow_unit : params.smallest_flow_unit,// 追加起点
			resList : renderList
		};
		// 起售日期
		rmParams.order_date_str = validateNumberDate(params.order_date_str) ? params.order_date_str.substr(0, 4) + "-" + params.order_date_str.substr(4, 2) + "-" + params.order_date_str.substr(6, 2)
				: "";// 起购
		// 到期日期
		rmParams.expire_date_str = validateNumberDate(params.expire_date_str) ? params.expire_date_str.substr(0, 4) + "-" + params.expire_date_str.substr(4, 2) + "-"
				+ params.expire_date_str.substr(6, 2) : "";// 到期
		rmParams.SECURITY_ALIAS = SECURITY_ALIAS;
        rmParams.cat_varieties = params.cat_varieties;
		var compiledTemplate = Template7.compile(ReadmeTemplate);
		var renderTemplate = compiledTemplate(rmParams);
		$$('#readmeContent').html(renderTemplate);
		if(SECURITY_ALIAS == "xsdzq"&&(params.category_id=='10005'||(params.category_id == '10014'&&params.product_status=='2')||(params.category_id == '10015'&&params.product_status=='2'))){ //新时代新发基金隐藏
            $$('.reminder').hide();
		}
		if (index_num == 0) {
			$$(".item-des-title.has-left-mark.buy").remove();
			$$(".item-des-content.desc").remove();
		}
		Utils.bindEvents(binddings);
	}

	// 加载产品详情底部
	function renderButtom(params, binddings) {
		params.btnClass = "";
		if (!params.showordispaly == "show") {
			params.btnClass = "btn-disabled";
		} else {
			params.btnClass = "buy";
		}
		var template = $$('#detailButtomTemplate').html();
		var compiledTemplate = Template7.compile(template);
		var renderTemplate = compiledTemplate(params);
		$$('#detailButtomContent').html(renderTemplate);
		Utils.bindEvents(binddings);
	}

	function stageGainLi(params, binddings) {
		var template = $$('#stageGainTemplate').html();
		var compiledTemplate = Template7.compile(template);
		var cat_varieties = params.cat_varieties;
		var category_id = params.category_id;
		if ('5' == cat_varieties || '12' == cat_varieties) {// 货币型(包括基金和资管)和短期理财产品
			params.currshort = '0';
		} else if ('10014' == category_id || '10015' == category_id) {// 非货币型资管产品
            params.currshort = '3';
        }else if ('5' != cat_varieties && '10006' == category_id) {
			params.currshort = '1';
		} else {
			params.currshort = '2';
		}
		var renderTemplate = compiledTemplate(params);
		$$('#stageGainContent').html(renderTemplate);
	}

	function renderzdb(params, binddings) {
		var template = $$('#zdbContentTemplate').html();
		var compiledTemplate = Template7.compile(template);
		var renderTemplate = compiledTemplate(params);
        renderTemplate=renderTemplate.replace(new RegExp('src="mall/getFile','gm'),'src="'+ SERVICE_DOMAIN_URL+'mall/getFile');
		$$('#zdbContent').html(renderTemplate);
	}
    function renderxf(params, binddings) {
        var template = $$('#xfContentTemplate').html();
        var compiledTemplate = Template7.compile(template);
        var renderTemplate = compiledTemplate(params);
        $$('#xfContent').html(renderTemplate);
    }
	return {
		renderTop : renderTop,
		renderMain : renderMain,
		renderReadme : renderReadme,
		renderButtom : renderButtom,
		stageGainLi : stageGainLi,
		renderzdb : renderzdb,
		renderFastenTemplate : renderFastenTemplate,
        renderxf : renderxf
	}
});
